package com.jasamedika.medifirst2000.converter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Component;

import com.google.gson.Gson;
import com.jasamedika.medifirst2000.converter.base.BaseVoConverter;
import com.jasamedika.medifirst2000.entities.PapProsedurePenanggungJawab;
import com.jasamedika.medifirst2000.vo.PapProsedurePenanggungJawabVO;

/**
 * Converter class between PAPProsedurePenanggungJawab and PAPProsedurePenanggungJawabVO
 * 
 * @author Askur
 */
@Component
public class PapProsedurePenanggungJawabConverter implements BaseVoConverter<PapProsedurePenanggungJawabVO, PapProsedurePenanggungJawab> {
	

	public PapProsedurePenanggungJawab transferVOToModel(PapProsedurePenanggungJawabVO vo, PapProsedurePenanggungJawab model) {
		if (null == model)
			model = new PapProsedurePenanggungJawab();
		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = vo.serialize(fieldsToInclude,vo.getClass().getName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        model = gson.fromJson(json, PapProsedurePenanggungJawab.class);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return model;

	}

	public List<PapProsedurePenanggungJawabVO> transferListOfModelToListOfVO(List<PapProsedurePenanggungJawab> models,
			List<PapProsedurePenanggungJawabVO> vos) {
		if (null == vos)
			vos = new ArrayList<PapProsedurePenanggungJawabVO>();

		if (null == models)
			return vos;

		for (PapProsedurePenanggungJawab PapProsedurePenanggungJawab : models) {
			PapProsedurePenanggungJawabVO vo = new PapProsedurePenanggungJawabVO();
			vo = transferModelToVO(PapProsedurePenanggungJawab, vo);
			vos.add(vo);
		}

		return vos;
	}

	@Override
	public PapProsedurePenanggungJawabVO transferModelToVO(PapProsedurePenanggungJawab model, PapProsedurePenanggungJawabVO vo) {

		if (null == vo)
			vo = new PapProsedurePenanggungJawabVO();
		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, PapProsedurePenanggungJawabVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return vo;
	
	}

	
}
